class Landscape
{
  PShape _landscape;
  PShape _landscape2ndPart;

  PVector _pos;
  String  _file;
  int     _landH; //height of file
  int     _landW; //width of file
  float   _speed;

  //constructor
  Landscape (String filepath, int w, int h, float speed) {
    _file = filepath;
    _landH = h;
    _landW = w;
    _landscape = loadShape(_file);
    _landscape2ndPart = loadShape(_file);
    _pos = new PVector(0, 0);
    _speed = speed;
  }

  void showLand() {
    if(_pos.x +_landW <= 0){
      _pos.x = 0;
    }
    
    shapeMode(CORNER);
    pushMatrix();
    translate(_pos.x, 0);
    shape(_landscape, 0, height-_landH, _landW, _landH);
    popMatrix();

    //seamless transition to second landscape
    pushMatrix();
    translate(_pos.x, 0);
    shape(_landscape2ndPart, _landW, height-_landH, _landW, _landH); 
    popMatrix();
    _pos.add(-_speed, 0, 0);
  }
}

