class Shot
{
  Timer _timer;

  PShape _shotShape;
  PShape _shotShape2;
  PVector _pos;
  PVector _dir;
  float   _height;
  float   _width;
  int     _h;
  int     _sType;
  final static int  SUICIDE     = 0; 
  final static int  REBOUNCE    = 1;
  final static int  NOTHING     = 2;


  //Constructor
  Shot(float x, float y, float size, int gameGUIbar_h, int shottype) {
    _pos = new PVector(x, y-13); //set position
    _dir = new PVector(0, 0);  //no direction at the beginning
    _height = size;
    _width = size*(33/7);
    _dir = new PVector(5, 0, 0);
    _shotShape = loadShape("shot.svg"); //33x7
    _shotShape2 = loadShape("shot2.svg"); 
    _h = gameGUIbar_h;
    _sType = shottype; //at start always 0 = normal shot
  }

  void update() {
    calcPos(); //get's new Position of the Spaceship
    pushMatrix();
    //    rotate(_dir.heading()); //rotates cordinates to angle of direction vector
    //    rectMode(CENTER);
    //    rect(_pos.x, _pos.y, _width, _height);
    shapeMode(CENTER);
    if (_sType == 0) {
      shape(_shotShape, _pos.x, _pos.y, _width, _height);
    } 
    else {
      shape(_shotShape2, _pos.x, _pos.y, _width, _height);
    }

    popMatrix();
  }

  void calcPos() { //update the PVectors for the positioning
    _pos.add(_dir);
    //    println(_dir);

    // test if shot hits top or bottom
    if (_pos.y - _height/2 <= _h || _pos.y +_height/2 >= height)  //falls an Oberkante oder an unterkante
    {
      _dir.y *= -1;
      if (_pos.y - _height/2 <= _h) {
        _pos.y = _h + _height/2;
      } 
      else if (_pos.y +_height/2 >= height) {
        _pos.y = height - _height/2;
      }
    }

    //red shot can't leave canvas
    if (_sType != 0) {
      if (_pos.x - _width/2 <= 0) {
        _dir.x *= -1;
        _pos.x = _width/2;
      } 
      else if (_pos.x + _width/2 >= width ) {
        _dir.x *= -1;
        _pos.x = width - _width/2;
      }
    }
  }

  boolean outOfScreen() {
    if ((_pos.x - _width) > width || (_pos.x < 0)) {
      //      println("out!");
      return true;
    } 
    else {
      return false;
    }
  }

  int killedYourself(float shipX, float shipY, float shipWidth, float shipHeight, boolean shieldActive) {
    //    println("UK " + (shipY + shipHeight/2) + " OK: " + (shipY - shipHeight/2) + " UKs"  +  (_pos.y + _height/2) + " OKs " + (_pos.y - _height/2));
    //    println("RK " + (shipX + shipWidth/2) + " LK " + (shipX - shipWidth/2) + " RKs " + _pos.x + " LKs " + (_pos.x + _width/2));
    //    if(shieldActive){
    //      shipWidth += 19;
    //    }
    if (_sType != 0) { //red shot does not kill the player!
      return NOTHING;
    }
    if (shipX + shipWidth/2 >= _pos.x && shipX - shipWidth/2 <= _pos.x + _width/2  &&       //check if shot has reached Spaceship X
    shipY + shipHeight/2 >= _pos.y - _height/2 && shipY - shipHeight/2 <= _pos.y + _height/2) {
      if (shieldActive) {
        println("bounced back");
        return REBOUNCE; //returns 1
      }
      println("suicide");
      return SUICIDE; //returns 0
    } 
    else {
      return NOTHING; //returns 2
    }
  }

  void timerStart() {
    _timer = new Timer(11000); //red shot should dissolve after 11000ms
    _timer.start();
  }
}

